"use strict";

// status： 
// 1 正常数据 
// 0 数据请求为空 
// -1 服务器异常
/* 广告接口url */
var adsUrl = "http://api.short.tv/webapi/ads";
/* 用户中心信息接口url */
var userInfoUrl = "http://api.short.tv/webapi/userinfo";
/* 视频详情页接口url */
var detailUrl = "http://api.short.tv/webapi/detail";
/* 频道分页列表url */
var channelUrl = "http://api.short.tv/webapi/channel";
// 视频详情页的视频地址
var playurl="http://api.short.tv/webapi/playurl";
//分享视频地址
var shareUrl="http://api.short.tv/web";

var ditto = {
	playurl:"http://api.short.tv/webapi/playurl",
	status:function(status){
		if (status==1) {
			console.log('请求成功');
		}else if(status==2){
			return;
		}else{
			$api.toast('ditto','服务器异常',1000);
		}

	},
	loading:function(){
		var loading=document.getElementById("loading");
		if (loading.style.display=='noen') {
			loading.style.display="block";
		} else{
			loading.style.display="none";
		}
	},
	head:function(){
		api.ajax({
		    url: "http://api.short.tv/webapi/head",
		    method: 'get',
		    timeout: 30,
		    dataType: 'json',
		},function(ret,err){
		    if (ret) {
		        //var data = JSON.stringify(ret);
				var gettpl = document.getElementById('sliderTpl').innerHTML;
				laytpl(gettpl).render(ret, function(html){
				    document.getElementById('sliderView').innerHTML = html;
				    var swiper = new Swiper('.swiper-container', {
				        slidesPerView: 'auto',
				        paginationHide:false,
				        autoplay : 3000,
				        autoplayDisableOnInteraction : true,
				        spaceBetween: 10
			    	});
				});
		    }else {
		    	$api.toast('ditto','没有网络，无法链接',1000);
		        api.toast({
	                msg: "没有网络，无法链接",
	                duration: 1000,
	                location: "top"
	            });
		    };
		});		

	},
	videoIndex:function(){
		api.ajax({
		    url: "http://api.short.tv/webapi/index",	//请求地址，不能为空
		},function(ret,err){
		    if (ret) {
				var pageCount = Math.ceil(ret.total / 10)
		        var urlJson = JSON.stringify(ret);
				var gettpl = document.getElementById('videoTpl').innerHTML;
				laytpl(gettpl).render(ret, function(html){
					ditto.loading();
					document.getElementById('videoView').setAttribute("data-count",pageCount);
				    document.getElementById('videoView').innerHTML = html;
				});
		    }else {
		       api.toast({
	                msg: "没有网络，无法链接",
	                duration: 2000,
	                location: "top"
	            });
		    };
		});
	},
	imageCache:function(url,callback){
		api.imageCache({
		    url: url
		},function(ret,err){
		    if (ret) {
		        callback(ret.url);
		    }
		});
	}
	
}

/**
 * [Edata 通用类]
 * @type {Object}
 */
var common = {
	/**
	 * 加载脚本
	 * @method LoadScript
	 * @for mamijd
	 * @param string src 加载地址.js
	 * @param function callback 加载完毕回调内容
	 * @param string charset 加载编码
	 * @return {html,json} document
	 */
	LoadScript: function(src, callback, charset) {
		var script = document.createElement('script');
		script.setAttribute('language', 'javascript');
		if (charset) {
			script.setAttribute('charset', charset);
		}
		script.setAttribute('type', 'text/javascript');
		// script.setAttribute('defer',` '');
		script.setAttribute('src', src);
		document.getElementsByTagName("head")[0].appendChild(script);
		if (document.all) {
			script.onreadystatechange = function() {
				if (this.readyState == 4 || this.readyState == 'complete' || this.readyState == 'loaded') {
					if (callback) {
						callback();
					}
				}
			};
		} else {
			script.onload = function() {
				if (callback) {
					callback();
				}
			};
		}
	},
	/**
	 * 打印对象
	 * @method dump_obj
	 * @for mamijd
	 * @param obj 对象
	 * @return string 对象下标
	 */
	dump_obj: function(myObject) {
		var s = "";
		for (var property in myObject) {
			s = s + "\n " + property + ": " + myObject[property];
		}
		alert(s);
	},
	/**
	 * 友好时间格式化
	 * @method jsDateDiff
	 * @for mamijd
	 * @param time unixtime 时间戳
	 * @return string 格式化后的距离天数
	 */
	jsDateDiff: function(unixtime) {
		var d_minutes, d_hours, d_days;
		var timeNow = parseInt(new Date().getTime() / 1000);
		var d;
		d = timeNow - unixtime;
		d_days = parseInt(d / 86400);
		d_hours = parseInt(d / 3600);
		d_minutes = parseInt(d / 60);
		if (d_days > 0 && d_days < 4) {
			return d_days + "天前";
		} else if (d_days <= 0 && d_hours > 0) {
			return d_hours + "小时前";
		} else if (d_hours <= 0 && d_minutes > 0) {
			return d_minutes + "分钟前";
		} else {
			var s = new Date(unixtime * 1000);
			// s.getFullYear()+"年";
			return s.getFullYear() + "年" + (s.getMonth() + 1) + "月" + s.getDate() + "日";
		}
	},
	back:function(){		
		api.historyBack(
		    function(ret, err){
		        if (ret.status){
					api.toast({msg: '返回成功',duration:2000,location: 'bottom'});
		        } else {
		        	api.setStatusBarStyle({style: 'light'});
		        	api.closeWin();
		        }
		    }
		);
	},
	historyForward:function(){

	},
	openUrl:function(url,model){
		if (model==1) {
			video.channel(url);
		}else if(model==2){
			api.openApp({
				androidPkg: 'android.intent.action.VIEW',
				mimeType: 'text/html',
				uri: url
			}, function(ret, err) {
				var msg = JSON.stringify(ret);
				api.alert({
					title: 'openApp',
					msg: msg,
					buttons: ['确定']
				});
			});
		}else{
			video.play(url);
		}
	},
	reflush:function(){
		api.execScript({
    		name: 'viewPage',
    		script: 'window.location.reload();'
		});	
	},
	getTopHeight: function(){
		var height=20;
		if (api.systemType != "ios") {
			height = 0;
		}
		return height;	
	},
	/**
	 * 刷新通用页
	 * @method flexEcho
	 * @for mamijd
	 * @param int time 延迟时间(s)
	 * @param function callback 回调事件(s)
	 * @return bool 返回成功或失败
	 */
	refreshPage: function(timeOut, callback) {
		
	},
	runScript: function(name, script) {
		api.execScript({
			name: name,
			script: script
		});
	},
	openFrm:function(name,url,header_h,rect_h){
		api.openFrame({
		    name: 'page2',
		    url: './page2.html',
		    rect: {
		    	x: 0, 
		    	y: header_h, 
		    	w: 'auto', 
		    	h: 'auto'
		    },
		    pageParam: {name: 'test'},
		    bounces: true,
		    opaque: false,
		    bgColor: 'rgba(0,0,0,0)',
		    vScrollBarEnabled:true,
		    hScrollBarEnabled:true
		});
	}
}

var video={
	play:function(vid){
		if (typeof(vid) != "undefined") {
			api.openWin({
			    name: 'video',
			    alone:"true",
			    url: './view.html',
			    pageParam: {vid: vid}
			});
		}else{
			api.toast({
                msg: "无效视频，请联系管理员！",
                duration: 1000,
                location: "bottom"
            });
		}
	},
	channel:function(chid){

		if (typeof(chid) != "undefined") {
			api.openWin({
			    name: 'channel',
			    alone:"false",
			    url: './channel.html',
			    pageParam: {chid: chid}
			});
		}else{
			api.toast({
                msg: "该分类还暂无内容",
                duration: 1000,
                location: "bottom"
            });
		}
	}



}
//video.play();
/**
 * 用户接口
 * @class {user}
 */
var user ={

	isLogin:function(){
	},
	regsite:function(){

	},
	userLogin:function(UserName,UserPwd){
		if (UserName!='' || UserPwd!='') {
				
		}else{

		}
	},
	weixin:function(share,type){
			
			if (type==0) {
				var scene="session";
			}else{
				var scene="timeline";
			}
			var weiXin = api.require('weiXin');
			common.dump_obj(share);
			/* 注册应用. */
			weiXin.registerApp(
			    function(ret,err){
			        if ( ! ret.status) {
			            api.toast({
			                msg: err.msg,
			                duration: 1000,
			                location: "top"
			            });
			            return;
			        }
			        alert(scene);

			        /* 分享内容 */
			        weiXin.sendRequest({
			            scene:scene,
			            contentType:'web_page',
			            title:"'"+share.title+"'",
			            description:"'"+share.desc+"'",
			            thumbUrl:"'"+share.img+"'",
			            contentUrl: "'"+share.url+"'",
			        },function(ret,err){
			            if( ! ret.status){
			                api.toast({
			                    msg: err.msg,
			                    duration: 1000,
			                    location: "top"
			                });
			                return;
			            }
			            api.toast({
			                msg: "分享成功",
			                duration: 1500,
			                location: "top"
			            });
			        });

			    }
			);

	},
	sinaWeiBo:function(share) {
		/* 登陆. */
		var sinaWeiBo = api.require('sinaWeiBo');

		sinaWeiBo.auth({
		    redirectUrl: 'http://www.short.tv'
		},function(ret,err){
		    if( ! ret.status){
		        api.toast({
		            msg: "登陆失败!",
		            duration: 1000,
		            location: "top"
		        });

		        return;
		    }
		    /* 分享. */
		    sinaWeiBo.sendRequest({
		        contentType: 'video',
		        text: share.title,
		        description:share.desc,
		        videoUrl:share.video,
		        imageUrl: share.img,
		        webpageUrl:share.url,
		    },function(ret,err){
		        if( ! ret.status){
		            api.toast({
		                msg: "分享失败!",
		                duration: 1000,
		                location: "top"
		            });
		            return;
		        }
		        api.toast({
		            msg: "内容已分享至新浪微博",
		            duration: 1000,
		            location: "top"
		        });
		    });
		});
	}
}


/**
 * 提示类
 */	
var tip={
	/**
	 * 提示信息
	 * @param  {string}
	 */
	msg:function(text) {
		api.alert({
			title: "提示",
			msg: text,
			buttons: ["确定"]
		})
	},
	
}

/**
 
 @Name : laytpl v1.1 - 精妙的JavaScript模板引擎
 @Author: 贤心
 @Date: 2014-08-16
 @Site：http://sentsin.com/layui/laytpl
 @License：MIT license
 
 */

;!function(win){
"use strict";

var config = {
    open: '{{',
    close: '}}'
};

var tool = {
    exp: function(str){
        return new RegExp(str, 'g');
    },
    //匹配满足规则内容
    query: function(type, _, __){
        var types = [
            '#([\\s\\S])+?',   //js语句
            '([^{#}])*?' //普通字段
        ][type || 0];
        return exp((_||'') + config.open + types + config.close + (__||''));
    },   
    escape: function(html){
        return String(html||'').replace(/&(?!#?[a-zA-Z0-9]+;)/g, '&amp;')
        .replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/'/g, '&#39;').replace(/"/g, '&quot;');
    },
    error: function(e, tplog){
        var error = 'Laytpl Error：';
        typeof console === 'object' && console.error(error + e + '\n'+ (tplog || ''));
        return error + e;
    }
};

var exp = tool.exp, Tpl = function(tpl){
    this.tpl = tpl;
};

Tpl.pt = Tpl.prototype;

//核心引擎
Tpl.pt.parse = function(tpl, data){
    var that = this, tplog = tpl;
    var jss = exp('^'+config.open+'#', ''), jsse = exp(config.close+'$', '');
    
    tpl = tpl.replace(/[\r\t\n]/g, ' ').replace(exp(config.open+'#'), config.open+'# ')
    .replace(exp(config.close+'}'), '} '+config.close).replace(/\\/g, '\\\\')
    .replace(/(?="|')/g, '\\').replace(tool.query(), function(str){
        str = str.replace(jss, '').replace(jsse, '');
        return '";' + str.replace(/\\/g, '') + '; view+="';
    }).replace(tool.query(1), function(str){
        var start = '"+(';
        if(str.replace(/\s/g, '') === config.open+config.close){
            return '';
        }
        str = str.replace(exp(config.open+'|'+config.close), '');
        if(/^=/.test(str)){
            str = str.replace(/^=/, '');
            start = '"+_escape_(';
        }
        return start + str.replace(/\\/g, '') + ')+"';
    });
    
    tpl = '"use strict";var view = "' + tpl + '";return view;';
    //console.log(tpl);
    try{
        that.cache = tpl = new Function('d, _escape_', tpl);
        return tpl(data, tool.escape);
    } catch(e){
        delete that.cache;
        return tool.error(e, tplog);
    }
};

Tpl.pt.render = function(data, callback){
    var that = this, tpl;
    if(!data) return tool.error('no data');
    tpl = that.cache ? that.cache(data, tool.escape) : that.parse(that.tpl, data);
    if(!callback) return tpl;
    callback(tpl);
};

var laytpl = function(tpl){
    if(typeof tpl !== 'string') return tool.error('Template not found');
    return new Tpl(tpl);
};

laytpl.config = function(options){
    options = options || {};
    for(var i in options){
        config[i] = options[i];
    }
};

laytpl.v = '1.1';

"function" == typeof define ? define(function() {
    return laytpl
}) : "undefined" != typeof exports ? module.exports = laytpl : window.laytpl = laytpl

}();
